import "mod_video";
import "mod_screen";
import "mod_map";
import "mod_key";
import "mod_dir";
import "mod_text";
import "mod_mem";
import "mod_proc";
import "mod_draw";
import "mod_timers";
import "mod_sort";
import "mod_string";
import "mod_file";
import "mod_say";
import "mod_joy";
import "mod_draw";
import "mod_rand";
import "mod_regex";

type fichero  // estructura del fichero igual a la de Bennu
		STRING path;
		STRING name;
		directory;
		hidden;
		readonly;
		size;
		STRING created;
		STRING modified;
		byte selected; // 0 no seleccionador, 1 si.
		string orden; // Variable para ordenar.
end

const
	_JKEY_UP = 0 ;
	_JKEY_UPLEFT = 1 ;
	_JKEY_LEFT = 2 ;
	_JKEY_DOWNLEFT = 3 ;
	_JKEY_DOWN = 4 ;
	_JKEY_DOWNRIGHT = 5 ;
	_JKEY_RIGHT = 6 ;
	_JKEY_UPRIGHT = 7 ;
	_JKEY_MENU = 8 ;
	_JKEY_SELECT = 9 ;
	_JKEY_L = 10 ;
	_JKEY_R = 11 ;
	_JKEY_A = 12 ;
	_JKEY_B = 13 ;
	_JKEY_X = 14 ;
	_JKEY_Y = 15 ;
	_JKEY_VOLUP = 16 ;
	_JKEY_VOLDOWN = 17 ;
	_JKEY_CLICK = 18 ;
	_JKEY_LAST = 19 ;
end

global
	string Directorio; //Directorio donde reside el programa.
	int jkeys[_JKEY_LAST];
	int jkeys_state[_JKEY_LAST];

	int Fuente;
	int FuentePuntero;
	int FuenteDirectorio;
	int nFuentes;
	fichero pointer pdirectorio; // Puntero al directorio completo
	int nLineas;  // n de lneas de pantalla
	byte nAltoLinea; // n de pixeles a mover por linea.
	byte nSeparacionX; // n de pixeles desde el principio de la pantalla.
	byte nSeparacionY;
	byte nColumnas; //n de columnas de la pantalla
	string Pantalla[30]; // Pantalla virtual.
	byte pointer pLineaLeida; // Linea leida del fichero.
	string FicheroCompleto; //Fichero de texto copleto.
	int pointer pLineas; // Puntero a la tabla de lineas.
	int CantidadLineas=0; //n de lneas en el fichero.
	int Puntero;    // Archivo que est actualmente seleccionado
	int n_Archivos;  //n de archivos total en el directorio (Incluido directorios)
	int primerArchivo; // 1er archivo visible
	string mascara; // Mscara por defecto.
	fichero tipofichero;
	int ideFichero; //Identificador del fichero abierto.
	byte TFichero; //0-binario, 1-texto 10, 2-texto 10+13.
	int PrincipioPantalla; //Posicin del principio de la pantalla en el fichero.
	int FinalPantalla; //Posicin de la ltima lnea leida.
	byte TamanoLetra; //Tamao de las letras. Por ahora 1,2,3.
end

private
	int tiempo=0;
	int contador;
	string borrame;
end

process Main()

begin

		Directorio=cd();
		set_fps(30,0);
		jkeys_set_default_keys();
		jkeys_controller();
		TamanoLetra=2;
		Fuente=load_fnt(Directorio+"/fuentes/f2w.fnt");
		FuentePuntero=load_fnt(Directorio+"/fuentes/f2g.fnt");
		FuenteDirectorio=load_fnt(Directorio+"/fuentes/f2y.fnt");
		nLineas=20;  // n de lneas de pantalla
		nAltoLinea=12;
		nSeparacionX=1;
		nSeparacionY=1;
		nColumnas=63; //n de columnas de la pantalla
		nFuentes=4;
		chdir("."); //seleccionamos una carpeta, que es la superior a la actual

		
		Free(pLineaLeida);
		pLineaLeida=calloc(sizeof(Byte),100); //100 es un mximo arbitrario
		// Si alloc=0 ERROR
		if (pLineaLeida ==0)
			write(0,0,0,0,"Error allocando memoria, ESC para salir");
			while(!jkeys_state[_JKEY_MENU]) frame; end
			exit();
		end
		
		
		Inicializar();

		repeat
			if (jkeys_state[_JKEY_down]) 
				Puntero++;
				PintaDirectorio();
				frame;
				timer[0]=0;
				while (timer[0]<30)
					frame; 
					if (!jkeys_state[_JKEY_DOWN ])
						timer[0]=50;
					end
				end
				while (jkeys_state[_JKEY_DOWN ])
					Puntero++;
					PintaDirectorio();
					frame;
				end
				frame;
			end
			if (jkeys_state[_JKEY_UP ]) 
				Puntero--;
				PintaDirectorio();
				frame;
				timer[0]=0;
				while (timer[0]<30)
					frame; 
					if (!jkeys_state[_JKEY_UP ])
						timer[0]=50;
					end
				end
				while (jkeys_state[_JKEY_UP ])
					Puntero--;
					PintaDirectorio();
					frame;
				end
				frame;
			end
			IF (jkeys_state[_JKEY_LEFT ])
				Puntero=Puntero-nLineas;
				PintaDirectorio();
				frame;
				timer[0]=0;
				while (timer[0]<30)
					frame; 
					if (!jkeys_state[_JKEY_LEFT ])
						timer[0]=50;
					end
				end
				while (jkeys_state[_JKEY_LEFT ])
					Puntero=Puntero-nLineas;
					PintaDirectorio();
					frame;
				end
			END
			IF (jkeys_state[_JKEY_right])
				Puntero=Puntero+nLineas;
				PintaDirectorio();
				frame;
				timer[0]=0;
				while (timer[0]<30)
					frame; 
					if (!jkeys_state[_JKEY_right])
						timer[0]=50;
					end
				end
				while (jkeys_state[_JKEY_right])
					Puntero=Puntero+nLineas;
					PintaDirectorio();
					frame;
				end
			END
			if (key(_space))
				if (pdirectorio[(Puntero+primerArchivo)].Selected==0)
					pdirectorio[(Puntero+primerArchivo)].Selected=1;
				else
					pdirectorio[(Puntero+primerArchivo)].Selected=0;
				end
				while (key(_space)) frame; end;
			end;
			if (key(_ins))
				if (pdirectorio[(Puntero+primerArchivo)].Selected==0)
					pdirectorio[(Puntero+primerArchivo)].Selected=1;
				else
					pdirectorio[(Puntero+primerArchivo)].Selected=0;
				end
				puntero++;
				PintaDirectorio();
				while (key(_ins)) frame; end;
			end;
			if (jkeys_state[_JKEY_B] and (pDirectorio[Puntero+primerArchivo].directory==1))
				chdir(pDirectorio[Puntero+primerArchivo].name);
				delete_text(0);
				//FREE(pDirectorio);
				inicializar();
				while (jkeys_state[_JKEY_B]) frame; end;
			elseif (jkeys_state[_JKEY_B])
				muestraFichero();
				Pintadirectorio();
				frame;
			end
			IF (jkeys_state[_JKEY_L])
				if (TamanoLetra>1)
					TamanoLetra--;
					Pantalla();
					Inicializar();
					PintaDirectorio();
				end
				while (!jkeys_state[_JKEY_L])
					frame;
				end
				while (jkeys_state[_JKEY_L])
					frame;
				end;
			END
			IF (jkeys_state[_JKEY_R])
				if (TamanoLetra<nFuentes)
					TamanoLetra++;
					Pantalla();
					Inicializar();
					PintaDirectorio();
				end
				while (!jkeys_state[_JKEY_R])
					frame;
				end
				while (jkeys_state[_JKEY_R])
					frame;
				end;
			END
			IF (jkeys_state[_JKEY_X])
				chdir("..");
				delete_text(0);
				inicializar();
				while (jkeys_state[_JKEY_X]) frame; end;
			END
			FRAME;
	until (jkeys_state[_JKEY_MENU])
	exit();
end
//------------------------------------------------------------------------------
function n_Archivos()
// Devuelve del n de archivos en el directorio en curso.
private 
	int contador=0;
	string Archivo;
end

begin
	Archivo=glob("");
	Archivo=glob(mascara);
	while (Archivo!="") /*buscamos un archivo cuyo nombre respete el patrn indicado*/
		if (fileinfo.name==".")
			contador--;
		end
		Archivo=glob(mascara);
		contador++;
	end;
	return contador;
end		
//------------------------------------------------------------------------------
function Inicializar()

begin
		Puntero=0;    // Archivo que est actualmente seleccionado
		n_Archivos=0;  //n de archivos total en el directorio (Incluido directorios)
		primerArchivo=0; // 1er archivo visible
		mascara="*.*"; // Mscara por defecto.
		timer[0]=0;
		principioPantalla=0;

		n_Archivos=n_Archivos(); // A ver cuantos entradas encuentro
		// Reservando memoria para el directorio


			Free(pDirectorio);
			pdirectorio=calloc(sizeof(tipofichero),n_Archivos);
			// Si alloc=0 ERROR
			if (pdirectorio ==0)
				write(0,0,0,0,"Error allocando memoria, ESC para salir");
				while(!jkeys_state[_JKEY_MENU]) frame; end
				exit();
			end
		
		// Llenamos la lista
		rellenaDirectorio();
		Pantalla();
		PintaDirectorio();
end

//-------------------------------------------------------------------------------------		
function rellenaDirectorio()
// Devuelve puntero al directorio relleno
private 
	int contador=0;
	string Archivo;
end

begin
	Archivo=glob("");
	Archivo=glob(mascara);
	while (Archivo!="") /*buscamos un archivo cuyo nombre respete el patrn indicado*/
		if (fileinfo.name!=".")
			pdirectorio[contador].name=fileinfo.name;
			pdirectorio[contador].created=fileinfo.created;
			pdirectorio[contador].selected=0;
			pdirectorio[contador].directory=fileinfo.directory;
			pdirectorio[contador].size=fileinfo.size;
			if (fileinfo.directory==0)
				pdirectorio[contador].orden="1"+ucase(fileinfo.name);
			else
				pdirectorio[contador].orden="0"+ucase(fileinfo.name);
			end
			contador++;
			Archivo=glob(mascara);
		else
			Archivo=glob(mascara);
		end
	end;
	ksort(pdirectorio,pdirectorio[0].orden,n_archivos);	
	return;
end		
//--------------------------------------------------------------------------------------
function pintaDirectorio()
// Pinta al directorio relleno
private 
	int contador=0;
	int contador2=0;
	string nombre;
end

begin
	delete_text(0);
	if (Puntero>=nLineas)
		PrimerArchivo=PrimerArchivo+Puntero-nLineas+1;
		Puntero=nLineas-1;
	end
	if (Puntero<0)
		PrimerArchivo=PrimerArchivo+Puntero;
		Puntero=0;
	end
	if (PrimerArchivo+Puntero>=n_Archivos)
		PrimerArchivo=n_Archivos-nLineas;
		Puntero=nLineas-1;
		if (Puntero>=n_Archivos)
			Puntero=n_Archivos-1;
		end
	end;
	if (PrimerArchivo<0)
		PrimerArchivo=0;
	end

	while ((contador<nLineas) and ((contador+primerArchivo)<n_Archivos))		
		nombre=pdirectorio[(contador+primerArchivo)].name;
		if (text_Width(FuentePuntero,nombre)>195)
			contador2=0;
			while (text_width(FuentePuntero,substr(nombre,0,len(nombre)-contador2))>195)
					contador2++;
			end
			nombre=substr(nombre,0,len(nombre)-contador2)+"...";
		end
		if (contador==Puntero)
			if (pdirectorio[(contador+primerArchivo)].directory==1)
				Write(FuentePuntero,nSeparacionY,contador*nAltoLinea+nSeparacionX,0, "[ "+nombre+" ]"); /*escribimos el nombre del archivo*/
				Write(FuentePuntero,240,contador*nAltoLinea+nSeparacionX,0,"DIR");/*y su fecha y hora de creacin*/
			else
				Write(FuentePuntero,nSeparacionY,contador*nAltoLinea+nSeparacionX,0,nombre); /*escribimos el nombre del archivo*/
				Write(FuentePuntero,240,contador*nAltoLinea+nSeparacionX,0,pdirectorio[(contador+primerArchivo)].size);/*y su fecha y hora de creacin*/
			end
		ELSE
			IF (pdirectorio[(contador+primerArchivo)].Selected==1)
				if (pdirectorio[(contador+primerArchivo)].directory==1)
					Write(FuenteDirectorio,nSeparacionY,contador*nAltoLinea+nSeparacionX,0,"[ "+nombre+" ]"); /*escribimos el nombre del archivo*/
					Write(FuenteDirectorio,240,contador*nAltoLinea+nSeparacionX,0,"DIR");
				else
					Write(Fuente,nSeparacionY,contador*nAltoLinea+nSeparacionX,0,nombre); /*escribimos el nombre del archivo*/
					Write(Fuente,240,contador*nAltoLinea+nSeparacionX,0,pdirectorio[(contador+primerArchivo)].size);/*y su fecha y hora de creacin*/
				end
			ELSE
				IF (pdirectorio[(contador+primerArchivo)].directory==1)
					Write(FuenteDirectorio,nSeparacionY,contador*nAltoLinea+nSeparacionX,0,"[ "+nombre+" ]"); /*escribimos el nombre del archivo*/
					Write(FuenteDirectorio,240,contador*nAltoLinea+nSeparacionX,0,"DIR");/*y su fecha y hora de creacin*/
				ELSE
					Write(Fuente,nSeparacionY,contador*nAltoLinea+nSeparacionX,0,nombre); /*escribimos el nombre del archivo*/
					Write(Fuente,240,contador*nAltoLinea+nSeparacionX,0,pdirectorio[(contador+primerArchivo)].size);/*y su fecha y hora de creacin*/
				end
			end
		end
		contador++;
	end;

	return;
end		
		
//--------------------------------------------------------------------------------------
function MuestraFichero()
// Nos muestra el fichero.	


begin
	ideFichero=fopen(pDirectorio[Puntero+primerArchivo].name,o_read);
	EsFicheroDe();
	FicheroCompleto="";
	if (TFichero>0)
		FicheroCompleto=File(pDirectorio[Puntero+primerArchivo].name);
		FicheroCompleto=regex_replace(chr(9)," ",FicheroCompleto);
		CalculaLineas();
	end
	
	PintaFichero(0); //Inicializamos.
	LOOP
		if (jkeys_state[_JKEY_DOWN ]) 
			PintaFichero(_down);
			frame;
			timer[0]=0;
			while (timer[0]<30)
				frame; 
				if (!jkeys_state[_JKEY_DOWN ])
					timer[0]=50;
				end
			end
			while (jkeys_state[_JKEY_DOWN ])
				PintaFichero(_down);
				frame;
			end
			frame;
		end
		if (jkeys_state[_JKEY_UP ]) 
			PintaFichero(_up);
			frame;
			timer[0]=0;
			while (timer[0]<30)
				frame; 
				if (!jkeys_state[_JKEY_UP ])
					timer[0]=50;
				end
			end
			while (jkeys_state[_JKEY_UP ])
				PintaFichero(_up);
				frame;
			end
			frame;
		end
		if (jkeys_state[ _JKEY_LEFT ]) 
			PintaFichero(_left);
			frame;
			timer[0]=0;
			while (timer[0]<30)
				frame; 
				if (!jkeys_state[ _JKEY_LEFT ])
					timer[0]=50;
				end
			end
			while (jkeys_state[ _JKEY_LEFT ])
				PintaFichero(_left);
				frame;
			end
			frame;
		end
		if (jkeys_state[_JKEY_right]) 
			PintaFichero(_right);
			frame;
			timer[0]=0;
			while (timer[0]<30)
				frame; 
				if (!jkeys_state[_JKEY_right])
					timer[0]=50;
				end
			end
			while (jkeys_state[_JKEY_right])
				PintaFichero(_right);
				frame;
			end
			frame;
		end
		IF (jkeys_state[_JKEY_L])
			if (TamanoLetra>1)
				TamanoLetra--;
				Pantalla();
				CalculaLineas();
				//RepintaTexto();
				PintaFichero(0);
			end
			while (!jkeys_state[_JKEY_L])
				frame;
			end
			while (jkeys_state[_JKEY_L])
				frame;
			end;
		end
		IF (jkeys_state[_JKEY_R])
			if (TamanoLetra<nFuentes)
				TamanoLetra++;
				Pantalla();
				CalculaLineas();
				PintaFichero(0);
			end
			while (!jkeys_state[_JKEY_R])
				frame;
			end
			while (jkeys_state[_JKEY_R])
				frame;
			end;
		end
		if (jkeys_state[_JKEY_X])
			fclose(idefichero);
			principioPantalla=0;
			while (jkeys_state[_JKEY_X]) frame; end;
			break; 
		end
		FRAME;
		END
end		
//--------------------------------------------------------------------------------------
function PintaFichero(int direccion)
// Nos muestra el fichero.	

begin

	switch (direccion)
		case 0: // Slo pinta.
			if (TFichero==0)
				ScrollFicheroBinario(0);
			else
				ScrollFicheroTexto(0);
			end	
		end
		case _down:
			if (TFichero==0)
				ScrollFicheroBinario(_down);
			else
				ScrollFicheroTexto(_down);
			end	
		end
		case _up:
			if (TFichero==0)
				ScrollFicheroBinario(_up);
			else
				ScrollFicheroTexto(_up);
			end	
		end
		case _left:
			if (TFichero==0)
				ScrollFicheroBinario(_left);
			else
				ScrollFicheroTexto(_left);
			end
		end
		case _right:
			if (TFichero==0)
				ScrollFicheroBinario(_right);
			else
				ScrollFicheroTexto(_right);
			end
		end
	end
end
//--------------------------------------------------------------------------------------
function ScrollFicheroBinario(int direccion)
// Nos muestra el fichero.	

private
	int contador=1;
	byte caracter;
	byte BytesLeidos;
	//string caracter;
	int Linea=0; //Lnea por la que voy escribiendo.
	byte tamano;
	string archivo="";
	int InicioRefresco;
	int nLineasTemp;
end

begin
	caracter=" ";
	switch (direccion)
		case 0: // Slo pinta.
				PrincipioPantalla=0;
				fseek(ideFichero,PrincipioPantalla,0);
				contador=0;
				delete_text(0);
				while (contador<=nLineas)
					Pantalla[contador]="";
					contador++;
				end
				while ((Linea<nLineas)and(!feof(ideFichero)))
					BytesLeidos=fread(pLineaLeida,nColumnas,ideFichero);
					contador=0;
					while (contador<BytesLeidos)
						if ((pLineaLeida[contador]>32)and(pLineaLeida[contador]<255))
							Pantalla[Linea]=Pantalla[Linea]+chr(pLineaLeida[contador]);
						else
							Pantalla[Linea]=Pantalla[Linea]+".";
						end
						contador++;
					end
					write_var(Fuente,nSeparacionY,Linea*nAltoLinea+nSeparacionX,0,Pantalla[Linea]);
					Linea++;
				end
				FinalPantalla=PrincipioPantalla+nColumnas*(linea);
			return;	
		end
		case _down: // Abajo **************************
			if  (!feof(ideFichero))
				fseek(ideFichero,FinalPantalla,0);
				PrincipioPantalla=PrincipioPantalla+nColumnas;
				while (Linea<nLineas-1)
					Pantalla[Linea]=Pantalla[Linea+1];
					Linea++;
				end
				Pantalla[Linea]="";
				BytesLeidos=fread(pLineaLeida,nColumnas,ideFichero);
				contador=0;
				while (contador<BytesLeidos)
					if ((pLineaLeida[contador]>32)and(pLineaLeida[contador]<255))
						Pantalla[Linea]=Pantalla[Linea]+chr(pLineaLeida[contador]);
					else
						Pantalla[Linea]=Pantalla[Linea]+".";
					end
					contador++;
				end
			end	
			FinalPantalla=PrincipioPantalla+nColumnas*(linea+1);
			return;	
		end	
			
		case _up: // Arriba *************************************
			if (PrincipioPantalla>0)
				FinalPantalla=PrincipioPantalla+nColumnas*(nLineas-1);
				PrincipioPantalla=PrincipioPantalla-nColumnas;
				fseek(ideFichero,PrincipioPantalla,0);
				Linea=nLineas;
				while (Linea>0)
					Pantalla[Linea]=Pantalla[Linea-1];
					Linea--;
				end
				Pantalla[Linea]="";
				BytesLeidos=fread(pLineaLeida,nColumnas,ideFichero);
				contador=0;
				while (contador<BytesLeidos)
					if ((pLineaLeida[contador]>32)and(pLineaLeida[contador]<255))
						Pantalla[Linea]=Pantalla[Linea]+chr(pLineaLeida[contador]);
					else
						Pantalla[Linea]=Pantalla[Linea]+".";
					end
					contador++;
				end
			end	
			return;	
		end	

		case _right:
			if  (!feof(ideFichero))
				contador=0;
				while (contador<=nLineas)
					Pantalla[contador]="";
					contador++;
				end
				PrincipioPantalla=PrincipioPantalla+nColumnas*(nLineas);
				fseek(ideFichero,PrincipioPantalla,0);
				while ((Linea<nLineas)and(!feof(ideFichero)))
					BytesLeidos=fread(pLineaLeida,nColumnas,ideFichero);
					contador=0;
					while (contador<BytesLeidos)
						if ((pLineaLeida[contador]>32)and(pLineaLeida[contador]<255))
							Pantalla[Linea]=Pantalla[Linea]+chr(pLineaLeida[contador]);
						else
							Pantalla[Linea]=Pantalla[Linea]+".";
						end
						contador++;
					end
					write_var(Fuente,nSeparacionY,Linea*nAltoLinea+nSeparacionX,0,Pantalla[Linea]);
					Linea++;
				end
				FinalPantalla=PrincipioPantalla+nColumnas*(linea);
				if(feof(ideFichero))
					PrincipioPantalla=PrincipioPantalla-nColumnas*(nLineas-Linea);
					fseek(ideFichero,PrincipioPantalla,0);
					contador=0;
					while (contador<=nLineas)
						Pantalla[contador]="";
						contador++;
					end
					Linea=0;
					while ((Linea<nLineas)and(!feof(ideFichero)))
						BytesLeidos=fread(pLineaLeida,nColumnas,ideFichero);
						contador=0;
						while (contador<BytesLeidos)
							if ((pLineaLeida[contador]>32)and(pLineaLeida[contador]<255))
								Pantalla[Linea]=Pantalla[Linea]+chr(pLineaLeida[contador]);
							else
								Pantalla[Linea]=Pantalla[Linea]+".";
							end
							contador++;
						end
						write_var(Fuente,nSeparacionY,Linea*nAltoLinea+nSeparacionX,0,Pantalla[Linea]);
						Linea++;
					end
					FinalPantalla=PrincipioPantalla+nColumnas*(linea);
				end
			end
			return;	
		end

		case _left:
			if (PrincipioPantalla>0)
				PrincipioPantalla=PrincipioPantalla-nColumnas*nLineas;
				if (PrincipioPantalla<1)
					PrincipioPantalla=0;
				end
				fseek(ideFichero,PrincipioPantalla,0);
				contador=0;
				while (contador<=nLineas)
					Pantalla[contador]="";
					contador++;
				end
				while ((Linea<nLineas)and(!feof(ideFichero)))
					BytesLeidos=fread(pLineaLeida,nColumnas,ideFichero);
					contador=0;
					while (contador<BytesLeidos)
						if ((pLineaLeida[contador]>32)and(pLineaLeida[contador]<255))
							Pantalla[Linea]=Pantalla[Linea]+chr(pLineaLeida[contador]);
						else
							Pantalla[Linea]=Pantalla[Linea]+".";
						end
						contador++;
					end
					write_var(Fuente,nSeparacionY,Linea*nAltoLinea+nSeparacionX,0,Pantalla[Linea]);
					Linea++;
				end
				FinalPantalla=FTell(ideFichero);
				return;	
			end
		end
	end
	
	
end		
//--------------------------------------------------------------------------------------
function CalculaLineas()
// Formatea el fiechero de texto.

private 
	int Longitud; //Longitud FicheroCompleto.
	int contador=0; //Tanto por ciento abierto.
	int contador2=0;
end

begin
	CantidadLineas=0;

	Longitud=len(FicheroCompleto);
	// Calculo cantidad de lneas.
	Contador=0;
	Contador2=0;
	while (contador<Longitud)
		contador++;
		contador2++;
		if ((FicheroCompleto[contador]==10)or(contador2==nColumnas)or(contador==Longitud))
			CantidadLineas++;
			contador2=0;
		end
	end
	// Pido memoria.
	Free(pLineas);
	pLineas=calloc(sizeof(int),CantidadLineas+2);
	// Si alloc=0 ERROR
	if (pLineas==0)
		write(0,0,0,0,"Error allocando memoria, ESC para salir");
		while(!jkeys_state[_JKEY_MENU]) frame; end
		exit();
	end
	//Relleno tabla de lineas.
	CantidadLineas=0;
	Contador=0;
	Contador2=0;
	pLineas[0]=0;
	CantidadLineas++;
	while (contador<Longitud)
		contador++;
		contador2++;
		if ((FicheroCompleto[contador]==10)or(contador2==nColumnas+1)or(contador==Longitud))
			pLineas[CantidadLineas]=contador;
			CantidadLineas++;
			contador2=0;
		end
	end
	pLineas[CantidadLineas]=contador;
	
	return;
end
//--------------------------------------------------------------------------------------
function ScrollFicheroTexto(int direccion)
// Nos muestra el fichero.	

private
	int contador=1;
	int Linea=0; //Lnea por la que voy escribiendo.
	int longitud; //Longitud del FicheroCompleto2;
end

begin
	Longitud=len(FicheroCompleto);
	switch (direccion)
		case 0: // Slo pinta.
			PrincipioPantalla=0;
			FinalPantalla=0;
			contador=0;
			delete_text(0);
			while (contador<=nLineas)
				Pantalla[contador]="";
				contador++;
			end
			linea=0;
			while ((Linea<nLineas)and(pLineas[FinalPantalla]<Longitud))
				Pantalla[Linea]=substr(FicheroCompleto,pLineas[FinalPantalla],pLineas[FinalPantalla+1]-pLineas[FinalPantalla]);
				write_var(Fuente,nSeparacionY,Linea*nAltoLinea+nSeparacionX,0,Pantalla[Linea]);
				Linea++;
				FinalPantalla++;
			end
			return;	
		end
		case _down: // Abajo **************************
			Linea=0;
			if  (pLineas[FinalPantalla]<Longitud)
				PrincipioPantalla++;
				while (Linea<nLineas-1)
					Pantalla[Linea]=Pantalla[Linea+1];
					Linea++;
				end
				Pantalla[Linea]=substr(FicheroCompleto,pLineas[FinalPantalla],pLineas[FinalPantalla+1]-pLineas[FinalPantalla]);
				FinalPantalla++;
			end
			return;	
		end	
			
		case _up: // Arriba *************************************
			if (PrincipioPantalla>0)
				Linea=nLineas;
				while (Linea>0)
					Pantalla[Linea]=Pantalla[Linea-1];
					Linea--;
				end
				Pantalla[Linea]="";
				PrincipioPantalla--;
				FinalPantalla--;
				Pantalla[Linea]=substr(FicheroCompleto,pLineas[PrincipioPantalla],pLineas[PrincipioPantalla+1]-pLineas[PrincipioPantalla]);
			end	
			return;	
		end	

		case _right:
			if (FinalPantalla<CantidadLineas-1)
				FinalPantalla=FinalPantalla+nLineas;
				if (FinalPantalla>CantidadLineas-1)
					FinalPantalla=CantidadLineas-1;
				end
				PrincipioPantalla=FinalPantalla-nLineas;
				Linea=0;
				while ((Linea<nLineas))
					Pantalla[Linea]=substr(FicheroCompleto,pLineas[PrincipioPantalla+Linea],pLineas[PrincipioPantalla+Linea+1]-pLineas[PrincipioPantalla+Linea]);
					Linea++;
				end
			end
			return;	
		end

		case _left:
			if (PrincipioPantalla>0)
				PrincipioPantalla=PrincipioPantalla-nLineas;
				if (PrincipioPantalla<1)
					PrincipioPantalla=0;
				end
				FinalPantalla=PrincipioPantalla+nLineas;
				Linea=0;
				while ((Linea<nLineas))
					Pantalla[Linea]=substr(FicheroCompleto,pLineas[PrincipioPantalla+Linea],pLineas[PrincipioPantalla+Linea+1]-pLineas[PrincipioPantalla+Linea]);
					Linea++;
				end
			end
			return;
		end
	end
	
	
end		
//--------------------------------------------------------------------------------------
function Pausa()
// Espera a que pulsemos una tecla	
private 
end

begin
	while (!jkeys_state[ _JKEY_Y ]) frame; end
	while (jkeys_state[ _JKEY_Y ]) frame; end;
end
//--------------------------------------------------------------------------------------
function EsFicheroDe();

private
	int contador=0;
	byte caracteres=0;
	byte SaltoDeLinea10=0;
	byte SaltoDeLinea13=0;
	byte Tab=0;
	byte Otros=0;
	byte caracter=0;
end

begin
	TFichero=0;
	//return;
	fseek(ideFichero,0,0);
	while ((contador<250)and(!feof(ideFichero)))
				fread(ideFichero,caracter);
				if ((caracter>31) and (caracter<255))
					caracteres++;
				else
					if (caracter==13)
						SaltoDeLinea13++;
					else
						if (caracter==10)
							SaltoDeLinea10++;
						else
							if (caracter==9)
								Tab++;
							else
								Otros++;
							end
						end
					end
				end
		contador++;
	end
	if (SaltoDeLinea13>0)
		TFichero=2;
	else
		TFichero=1;
	end
	if (Otros>0)
		TFichero=0;
	end
	fseek(ideFichero,0,0);
end
//--------------------------------------------------------------------------------------
function Pantalla();

private
end

begin
	delete_text(0);
	switch (TamanoLetra)
		case (1):
			Unload_fnt(Fuente);
			Unload_fnt(FuentePuntero);
			Unload_fnt(FuenteDirectorio);
			Fuente=load_fnt(Directorio+"/fuentes/f1w.fnt");
			FuentePuntero=load_fnt(Directorio+"/fuentes/f1g.fnt");
			FuenteDirectorio=load_fnt(Directorio+"/fuentes/f1y.fnt");
			nLineas=30;  // n de lneas de pantalla
			nAltoLinea=8;
			nColumnas=79; //n de columnas de la pantalla
		end
		case (2):
			Unload_fnt(Fuente);
			Unload_fnt(FuentePuntero);
			Unload_fnt(FuenteDirectorio);
			Fuente=load_fnt(Directorio+"/fuentes/f2w.fnt");
			FuentePuntero=load_fnt(Directorio+"/fuentes/f2g.fnt");
			FuenteDirectorio=load_fnt(Directorio+"/fuentes/f2y.fnt");
			nLineas=18;  // n de lneas de pantalla
			nAltoLinea=13;
			nSeparacionX=2;
			nSeparacionY=2;
			nColumnas=63; //n de columnas de la pantalla
		end
		case (3):
			Unload_fnt(Fuente);
			Unload_fnt(FuentePuntero);
			Unload_fnt(FuenteDirectorio);
			Fuente=load_fnt(Directorio+"/fuentes/f3w.fnt");
			FuentePuntero=load_fnt(Directorio+"/fuentes/f3g.fnt");
			FuenteDirectorio=load_fnt(Directorio+"/fuentes/f3y.fnt");
			nLineas=18;  // n de lneas de pantalla
			nAltoLinea=13;
			nColumnas=52; //n de columnas de la pantalla
		end
		case (4):
			Unload_fnt(Fuente);
			Unload_fnt(FuentePuntero);
			Unload_fnt(FuenteDirectorio);
			Fuente=load_fnt(Directorio+"/fuentes/f4w.fnt");
			FuentePuntero=load_fnt(Directorio+"/fuentes/f4g.fnt");
			FuenteDirectorio=load_fnt(Directorio+"/fuentes/f4y.fnt");
			nLineas=17;  // n de lneas de pantalla
			nAltoLinea=14;
			nColumnas=39; //n de columnas de la pantalla
		end
	end
	//frame;
end
//--------------------------------------------------------------------------------------
function jkeys_set_default_keys()
begin
	jkeys[ _JKEY_UP ] = _UP ;
	jkeys[ _JKEY_UPLEFT ] = 0 ;
	jkeys[ _JKEY_LEFT ] = _LEFT ;
	jkeys[ _JKEY_DOWNLEFT ] = 0 ;
	jkeys[ _JKEY_DOWN ] = _DOWN ;
	jkeys[ _JKEY_DOWNRIGHT ] = 0 ;
	jkeys[ _JKEY_RIGHT ] = _RIGHT ;
	jkeys[ _JKEY_UPRIGHT ] = 0 ;
	jkeys[ _JKEY_MENU ] = _ESC ;
	jkeys[ _JKEY_SELECT ] = 0 ;
	jkeys[ _JKEY_L ] = _O ;
	jkeys[ _JKEY_R ] = _P ;
	jkeys[ _JKEY_A ] = _A ;
	jkeys[ _JKEY_B ] = _ENTER ;
	jkeys[ _JKEY_X ] = _BACKSPACE;
	jkeys[ _JKEY_Y ] = _W ;
	jkeys[ _JKEY_VOLUP ] = 0 ;
	jkeys[ _JKEY_VOLDOWN ] = 0 ;
	jkeys[ _JKEY_CLICK ] = 0 ;
end
/* -------------------------------------------------------------------------- */
process jkeys_controller()
private
	i;
begin
	signal_action( s_kill, s_ign );
	signal( type jkeys_controller, s_kill );
	signal_action( s_kill, s_dfl );
	loop
		for ( i = 0; i < _JKEY_LAST; i++ )
		if ( jkeys[i] )
			jkeys_state[i] = key( jkeys[i] );
		else
			jkeys_state[i] = 0;
		end
	end
	if ( os_id == OS_GP2X_WIZ && joy_number() ) /* Wiz */
		jkeys_state[ _JKEY_UP ] |= joy_getbutton( 0, _JKEY_UP );
		jkeys_state[ _JKEY_UPLEFT ] |= joy_getbutton( 0, _JKEY_UPLEFT );
		jkeys_state[ _JKEY_LEFT ] |= joy_getbutton( 0, _JKEY_LEFT );
		jkeys_state[ _JKEY_DOWNLEFT ] |= joy_getbutton( 0, _JKEY_DOWNLEFT );
		jkeys_state[ _JKEY_DOWN ] |= joy_getbutton( 0, _JKEY_DOWN );
		jkeys_state[ _JKEY_DOWNRIGHT ] |= joy_getbutton( 0, _JKEY_DOWNRIGHT );
		jkeys_state[ _JKEY_RIGHT ] |= joy_getbutton( 0, _JKEY_RIGHT );
		jkeys_state[ _JKEY_UPRIGHT ] |= joy_getbutton( 0, _JKEY_UPRIGHT );
		jkeys_state[ _JKEY_MENU ] |= joy_getbutton( 0, _JKEY_MENU );
		jkeys_state[ _JKEY_SELECT ] |= joy_getbutton( 0, _JKEY_SELECT );
		jkeys_state[ _JKEY_L ] |= joy_getbutton( 0, _JKEY_L );
		jkeys_state[ _JKEY_R ] |= joy_getbutton( 0, _JKEY_R );
		jkeys_state[ _JKEY_A ] |= joy_getbutton( 0, _JKEY_A );
		jkeys_state[ _JKEY_B ] |= joy_getbutton( 0, _JKEY_B );
		jkeys_state[ _JKEY_X ] |= joy_getbutton( 0, _JKEY_X );
		jkeys_state[ _JKEY_Y ] |= joy_getbutton( 0, _JKEY_Y );
		jkeys_state[ _JKEY_VOLUP ] |= joy_getbutton( 0, _JKEY_VOLUP );
		jkeys_state[ _JKEY_VOLDOWN ] |= joy_getbutton( 0, _JKEY_VOLDOWN );
		jkeys_state[ _JKEY_CLICK ] |= joy_getbutton( 0, _JKEY_CLICK );
		jkeys_state[_JKEY_UP ] |= jkeys_state[ _JKEY_UPLEFT ] | jkeys_state[ _JKEY_UPRIGHT ];
		jkeys_state[_JKEY_DOWN]|= jkeys_state[_JKEY_DOWNRIGHT ] | jkeys_state[ _JKEY_DOWNLEFT ];
		jkeys_state[_JKEY_LEFT ] |= jkeys_state[ _JKEY_UPLEFT ] | jkeys_state[ _JKEY_DOWNLEFT ];
		jkeys_state[_JKEY_RIGHT] |= jkeys_state[ _JKEY_UPRIGHT ]| jkeys_state[ _JKEY_DOWNRIGHT ];
	end
	frame;
	end
end
//--------------------------------------------------------------------------------------
